/**********************************************
* Copyright (c) 2021-2022 Crypto Quantique Ltd 
***********************************************/


#include <stdint.h>
#include <stddef.h>


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef qlLibrary_H
#define qlLibrary_H

// ATECC 608 slot ID's
#define SLOT_0              0     // for initial TLS 
#define SLOT_2              2     // for DSKCRS for quarklink enrol

int getDeviceId(char *deviceID);
int provision(char *pcEnrolResponse,char *pcUrl,uint16_t *sPortNum);
int retrieveIoTdetail(char *pcUrl,uint16_t *sPortNum);
int removeIoTdetail(void);

int createESKCSR(char *pcCSRout, char* deviceID,uint8_t *publicKeyDer,size_t *pxOutWritten);
int createDSKCSR(char *pcCSRout, char* deviceID,uint8_t *publicKeyDer,size_t *pxOutWritten);

int getPublicKey(uint8_t *public_key_DER,uint32_t slot);

int urlEncode(const char *pcIn, size_t xInLen,
			  char *pcOut, size_t xOutLen, size_t *pxOutWritten);

uint32_t parse(char *inStr,char *startStr,char *endStr,int radix);

struct ProvisionedDetails {
	   char  dcrt[1500];
	   char  iotHubURL[100];
	   int   iotHubPort;
	   char  iotHubCert[1500];
	   char  deviceID[65];
};


#endif /* qlprovisioningdetails_H*/
